#define PROGNAME "Quicknew"

#include "bbs:bgcheck/bgcheck.h"

static const char VersionTag[] = "\0$VER: "PROGNAME" "REVISION" by "AUTHOR" at "REVDATE" "REVTIME"";
void main(int argc, char *argv[])
{

	BPTR	readfh=NULL;
	char	buffer[500]="",buffer2[500]="",buffer3[500],buffer4[20],buffer5[20],filecolour[50]="[0m",*p=NULL,**files=NULL,**files2=NULL,**main_config=NULL,
			date[10]="",bytestr[3]="b";
	long    position=0,pos=0,pos2=0,pos3=0,len=0,filenumb=0,count=0,upfiles=0,tempbytes=0;
	BOOL	stop=FALSE,dlc=TRUE,already=FALSE,noansi=FALSE;
	float	upbytes=0;

	if (argc!=3 && argc!=4) 
	{
		printf("[36;44m Quicknew V1.1 by Joe Cool  [0m\n");
		printf("Usage: Quicknew <dirfile|Quicknewdatafile> <ansi-design.file|Name of conference> [<Colour of files>] \n");
		printf("Example: Quicknew bbs:conf02/dir2 bbs:designs/amigadesign \"ESC[36m\"\n\n");
		printf("- You can select a simple dirfile to scan for, or the logfile of quicknew-\n");
		printf("  starttool for the BGExtractor\n\n");
		printf("- If you just have a ansi-design.file then the strings @NR@ and @UPBYTES@\n");
		printf("  will be replaced with the uploaded number of files and bytes\n");
		printf("\n- You can select the colour of the files by using an Escape sequence\n\n");
		exit(0);
	}
	
	if (argc==4) strcpy(filecolour,argv[3]);

	Date(date,FORMAT_USA);

	files=(char **) realloc(files,sizeof(char *));
	files[0]=NULL;

	sprintf(buffer,"%s",argv[1]);
	readfh=Open(buffer,MODE_OLDFILE);
	if (readfh)
	{
		FGets(readfh,buffer,254);
		if (strncmp(buffer,"@QUICKNEW@",10))
		{
			Seek(readfh,0,OFFSET_BEGINNING);
			while(FGets(readfh,buffer,254))
			{		

				if (buffer[0]!=' ')
				{
					if (strncmp(buffer+23,date,8)==0)
					{
						for (pos=0;buffer[pos]!=' ';pos++)
						{
							buffer2[pos]=buffer[pos];
						}
							buffer2[pos]='\0';
						if (buffer2[20]=='k') upbytes+=(atoi(buffer+14)*1024);
						else upbytes+=atoi(buffer+14);
						upfiles++;
						files=(char **) realloc(files,(pos2+1)*sizeof(char *));
						files[pos2]=NULL;
							len=strlen(buffer2);
							files[pos2]=(char *) malloc (len+1);
						if (files[pos2]!=NULL)
							strcpy(files[pos2],buffer2);
						pos2++;
						files=(char **) realloc(files,(pos2+1)*sizeof(char *));
						files[pos2]=NULL;
					}
				}
			}	
		}
		else
		{
			FGets(readfh,buffer,254);
			if (!strncmp(buffer,date,8))
			
			while(FGets(readfh,buffer,254))
			{		
				sscanf(buffer,"%s %s",buffer2,buffer3);
				upbytes+=atoi(buffer3);
				upfiles++;
				files=(char **) realloc(files,(pos2+1)*sizeof(char *));
				files[pos2]=NULL;
					len=strlen(buffer2);
					files[pos2]=(char *) malloc (len+1);
				if (files[pos2]!=NULL)
					strcpy(files[pos2],buffer2);
				pos2++;
				files=(char **) realloc(files,(pos2+1)*sizeof(char *));
				files[pos2]=NULL;
			}
		
		}	
								
		
	}

	Close(readfh);


	if (upbytes>1023) 
	{
		upbytes=upbytes/1024.0;
		strcpy(bytestr,"kB");
	}
	if (upbytes>1023) 
	{
		upbytes=upbytes/1024.0;
		strcpy(bytestr,"mB");
	}
	
	sprintf(buffer,"%.2f%s",upbytes,bytestr);
	sprintf(buffer4,"%-9.9s",buffer);
	sprintf(buffer,"%d",upfiles);
	sprintf(buffer5,"%-4.4s",buffer);

	if (argc>=3)
	{

		readfh=Open(argv[2],MODE_OLDFILE);
		if (!readfh) noansi=TRUE;
		else
		{	
			while (FGets(readfh,buffer,499))
			{	
				replace(buffer,buffer2,buffer3,"@NR@",buffer5);
				replace(buffer2,buffer,buffer3,"@UPBYTES@",buffer4);
				printf(buffer);
			}
			Close(readfh);
			printf("   [35m......\n");
			printf("   :\n");
		}

	}
		

		
	len=0;
	if (noansi)
	{
		printf("[36m                         Todays Uploads in %s[0m\n",argv[2]);
		printf("                    Uploaded Files: %d  Bytes: %.2f%s    \n\n",upfiles,upbytes,bytestr);
	}


	for (pos=0;files[pos];pos++)
	{
		if (len==0 && pos==0 && !noansi)
		{
			printf("   :%s ",filecolour);
		}
		if (len==0 && pos==0 && noansi)
		{
			sprintf(buffer,"    %s ",filecolour);
			printf(buffer);	
		}
		if (len==0 && pos!=0) printf("    %s ",filecolour);
		printf("%13.13s",files[pos]);
		len++;
		if (len==5 && noansi) 
		{
			len=0;
			printf("\n");
		}

		if (len==5 && !noansi) 
		{
			len=0;
			printf("[35m   :\n");
			
		}
	}

	for(pos2=5;pos2>len;pos2--) printf("             ");

	if (noansi) printf("\n[36m                                               [44mQuicknew by Joe Cool[0m\n");
	else
	{
		printf("   [35m:\n");
		printf("  [35m __  [36m[44mDesign bY oR!On^sE[40m                        [44mQuicknew by Joe Cool[40m    [35m\n");
		printf("   \\/-------------------------------------------------------------------\\/[0m\n");
	}
	for (pos=0;files[pos];pos++)
		free(files[pos]);
	free(files);	

}

