#define PROGNAME "Sentby"		 /***/

#include "bbs:bgcheck/bgcheck.h"
#include "aedoor.h"

static const char VersionTag[] = "\0$VER: "PROGNAME" "REVISION" by "AUTHOR" at "REVDATE" "REVTIME"";
void Start(int node);

void main(int argc, char *argv[])
{

	int	Node=0;
if(argc<2)
{
	printf("Sorry, %s must be called from S!X or /X\n",argv[0]);
	exit(0);
}
Node=atoi(argv[1]);
Register(Node);

XIM_Msg->Command=140;                    
CheckMessage();
SetTaskPri(FindTask(0),atol(XIM_Msg->String));

Start(Node);
ShutDown();

}



void Start(Node)
{

	char	buffer[255],
			sentby[50]="",
			sentby2[50]="",
			*ptr=NULL,
			file[255],
			playpen[255],	
			buffer2[400],
			slot[5],
			*p=NULL,
			**main_config=NULL;
	BPTR	lock=NULL,
			fh=NULL;
	int		len=0,
			pos=0,
			inputlen=44;



ws("[36m",1);
ws("       __                                                ",1);
ws("    _/\\\\/_ [36;44mSentby Line Editor by Joe Cool[0m[36m _\\_____________:_ _",1);
ws("   |/  \\/                                  \\\\            |",1);
ws("   /    [35m.--------------------------------------------.[36m   |",1);
ws("  |    [35m:                                            :[36m   |",1);
ws("   |    [35m`--------------------------------------------'[36m   | ",1);
ws("_ _|___\\\\_____________________________________________/\\_|/",1);
ws("   :     \\                                              \\/",1);
ws("   .[0m",1);



	lock  = Lock( "bbs:bgcheck/Sentby", ACCESS_READ );
	if (lock)
	{
		UnLock(lock);
	}
	else 
	{
		lock = CreateDir( "bbs:bgcheck/Sentby" );
		if (!lock) 
		{
			ws("Somethings wrong with your System!",1);
			return;
		}
		else UnLock(lock);
	}


	strcpy(buffer,"bbs:bgcheck/bgfilehandler.config");
	fh=Open(buffer,MODE_OLDFILE);
	if (fh) 
	{
		for (pos=0;FGets(fh,buffer,254);pos++)
		{
			main_config=(char **) realloc(main_config,(pos+1)*sizeof(char *));
			main_config[pos]=NULL;
			len=strlen(buffer);
			if (buffer[len-1]=='\n') buffer[--len]='\0';
			upperstring(buffer);
				main_config[pos]=(char *) malloc (len+1);
			if (main_config[pos]!=NULL)
				strcpy(main_config[pos],buffer);
		}
		Close(fh);
		main_config=(char **) realloc(main_config,(pos+1)*sizeof(char *));
		main_config[pos]=NULL;
	}
	else
	{
		main_config=(char **) realloc(main_config,sizeof(char *));
		main_config[0]=NULL;
	}

	if (p=getconfig(main_config,"NEW_SENTBY")) inputlen=34;

	for (pos=0;main_config[pos];pos++)
		free(main_config[pos]);
	free (main_config);


	ws("[5A[9C",0);
	GetDT(DT_SLOTNUMBER,"\0");
	strcpy(slot,XIM_Msg->String);

	sprintf(buffer,"bbs:bgcheck/Sentby/Sentby.%s",slot);
	lock  = Lock( buffer, ACCESS_READ );
	if (lock)
	{
		fh = OpenFromLock(lock);
		if (!fh) UnLock(lock);
		else
		{
			FGets(fh,sentby,50);
			Close(fh);
		}
		if (sentby[strlen(sentby)-1]=='\n') sentby[strlen(sentby)-1]='\0';
	}
	if (strlen(sentby)>inputlen) 
	{
		strncpy(buffer,sentby,inputlen);
		buffer[inputlen]='\0';
		strcpy(sentby,buffer);
	}
	if (inputlen==34) ws("      ",0);
	GetStr(inputlen,sentby);
	strcpy(sentby2,XIM_Msg->String);
	Hotkey("[2B[11CDo you want to center your Tag-String? (y/N)");
	if (XIM_Msg->String[0]=='y' || XIM_Msg->String[0]=='Y')
	{
		pos=0;
		while(sentby2[pos]==' ')
		{
			pos++;
		}
		strcpy(buffer,sentby2+pos);
		strcpy(sentby2,buffer);
		len=strlen(sentby2);
		len=(inputlen-len)/2;
		strcpy(buffer,"");
		for(;len;len--)
		{
			strcat(buffer," ");
		}
		strcat(buffer,sentby2);
		strcpy(sentby2,buffer);
		ws("",1);
		ws("[4A[9C                                            [44D",0);
		if (inputlen==34) ws("      ",0);
		ws(sentby2,1);
		ws("",1);
		ws("",1);
	}
		ws("",1);
		ws("",1);




	if (XIM_Msg->Data==-1) return;
	if (strcmp(sentby,sentby2)!=0)
	{
		strcpy(sentby,sentby2);
		sprintf(buffer,"bbs:bgcheck/Sentby/Sentby.%s",slot);
		fh=Open(buffer,MODE_NEWFILE);
		if(!fh) 
		{
			ws("Sorry couldn`t write Sentby to Disk!",1);
			return;
		}	

		sprintf(buffer,"%s\n",sentby);
		FPuts(fh,buffer);
		Close(fh);
	}

}



