#define PROGNAME "Callerslogfix"

#define CHECKMARK_1 "Loss Carrier"
#define CHECKMARK_2 "Off Normally"
#define CHECKMARK_3 "word Failure"
#define CHECKMARK_4 "D CONNECT = "
#define CHECKMARK_5 "= NO CARRIER"

#include "bbs:bgcheck/bgcheck.h"


static const char VersionTag[] = "\0$VER: "PROGNAME" "REVISION" ("REVDATE")";


void main( int argc, char *argv[] )
{
	BOOL	fixxen = TRUE,files=FALSE,callbatch=FALSE;
	char	buffer[255],buffer2[255],**filenames=NULL;
	BPTR	fh=NULL;
	long	position=0,countfiles=0,len=0;
	ULONG	bytes=0;
	

	if (argc!=3)
	{
		printf(" Usage: C-FIX <Nodenumber> <logoffbatch>\n");
		exit(0);
	}	
	else
	{
			filenames=(char **) realloc(filenames,sizeof(char *));
			filenames[0]=NULL;

			sprintf(buffer,"bbs:node%s/Callerslog",argv[1]);
			fh=Open(buffer,MODE_READWRITE);
			Seek(fh,-13,OFFSET_END);
			FGets(fh,buffer,13);
			Close(fh);
			if (buffer[strlen(buffer)-1]=='\n') buffer[strlen(buffer)-1]='\0';
			if (!strcmp(buffer,CHECKMARK_1)) fixxen=FALSE;
			if (!strcmp(buffer,CHECKMARK_2)) fixxen=FALSE;
			if (!strcmp(buffer,CHECKMARK_3)) fixxen=FALSE;
			if (!strcmp(buffer,CHECKMARK_4)) fixxen=FALSE;
			if (!strcmp(buffer,CHECKMARK_5)) fixxen=FALSE;
			if (fixxen)
			{	
				printf("Fixing Callerslog! Please Wait!\n");

			sprintf(buffer,"bbs:node%s/Callerslog",argv[1]);
			fh=Open(buffer,MODE_READWRITE);
			Seek(fh,-20000,OFFSET_END);
			while(FGets(fh,buffer,254))
			{	
	
				if (!strncmp(buffer,"**********",10))
				{
					position=Seek(fh,0,OFFSET_CURRENT);
				}
			}	

			Seek(fh,position,OFFSET_BEGINNING);


			while(FGets(fh,buffer,254))
			{
				
				if (strstr(buffer,"Added") && strstr(buffer,"for the File called"))
				{
					bytes+=atoi(strstr(buffer,"Added")+6);
					strcpy(buffer2,strtok((strstr(buffer,"for the File called")+19)," "));
					files=TRUE;
					
					filenames=(char **) realloc(filenames,(countfiles+1)*sizeof(char *));
					filenames[countfiles]=NULL;
					len=strlen(buffer2);
						filenames[countfiles]=(char *) malloc (len+1);
					if (filenames[countfiles]!=NULL)
						strcpy(filenames[countfiles],buffer2);
					countfiles++;
					filenames=(char **) realloc(filenames,(countfiles+1)*sizeof(char *));
					filenames[countfiles]=NULL;

				}
				if (files)
				{
					if (strstr(buffer,"efficiency.") && strstr(buffer,"file(s),") && strstr(buffer,"bytes,") && strstr(buffer,"minute(s)."))
					{	
						files=FALSE;
        				for (countfiles=0;filenames[countfiles];countfiles++)
							free(filenames[countfiles]);
						free(filenames);
						bytes=0;
		                countfiles=0;
					}
				}
	
			}
			
			if (files && countfiles) 
			{
				while (FGets(fh,buffer,255));
				sprintf(buffer2,"\t%3d file(s), %dk bytes, 0 minute(s). 0 second(s), 0 cps, 0 %% efficiency.\n",countfiles,bytes/1024);
				FPuts(fh,buffer2);

   				for (countfiles=0;filenames[countfiles];countfiles++)
				{
					sprintf(buffer2,"bbs:node%s/Playpen/%s",argv[1],filenames[countfiles]);
					DeleteFile(buffer2);
				}

			}
			Date(buffer2,FORMAT_USA);	
			FPuts(fh,buffer2);
			FPuts(fh," (");
			timenow(buffer2);
			FPuts(fh,buffer2);
			FPuts(fh,":00) C-Fix fixed CallersLog! Off Loss Carrier\n");
			Close(fh);
			callbatch=TRUE;
		}
	}
	for (countfiles=0;filenames[countfiles];countfiles++)
		free(filenames[countfiles]);
	free(filenames);

	if (callbatch)
	{
		sprintf(buffer2,"Execute %s",argv[2]);
		System(buffer2,NULL);
	}
}
