#define PROGNAME "BGFileHandler"
#include"bbs:bgcheck/bgcheck.h"
#include "aedoor.h"
static const char VersionTag[] = "\0$VER: "PROGNAME" "REVISION" by "AUTHOR" at "REVDATE" "REVTIME"";

int main(int argc, char *argv[])
{
        
        char    buffer[500],                    buffer2[500],                   buffer3[500],
                        buffer4[500],                   **main_fileid=NULL,
                        movetopath[255]="\0",   exfilepath[20],                 date[10],
                        endung[12]="",                          timestr[10],                    *chp=NULL,
                        **main_filepaths=NULL,  fcheck='N',                             **main_config=NULL,
                        *p=NULL,                                
                        slot[6],                                sentby[50]="\0",                centholdpath[255]="",
                        starttool[500]="",                                              colour_sent1_bracket[20]="",
                        colour_sent1_sentby[20]="",                             colour_sent1_node[20]="",
                        colour_sent1_time[20]="",                               colour_sent2[20]="",
                        colour_clear[5]="",                                             free_comment[100]="            >>> Free download! <<<",
                        delaypath[255]="bbs:bgcheck/Delay/",    delaydate[10]="",
                        delaytime[10]="",                                               filename[13],
                        filepath[255],                                                  nodenumber[3],
                        handle[50],                                                             confpath[255],
                        slotnumber[6],          
                        autofree_mail_subject[31]=">> Freedownload! <<",
                        autofree_mail_fromname[31]="BGChecker",
                        fileiddate[10]="",
                        fileid_ad[46]="";

        int             counter=0,                              maxfidlines=20,                 confnumber=0,
                        ndirs=0,                                len=0,
                        mailaxx=255,                    mailaxx2=0;

        long    filesize=0;

        ULONG   stat=0,                                 pos=0,                                  dirinkbyte=0;

        UBYTE   dateformat=FORMAT_USA;

        BPTR    fh=NULL,                                readfh=NULL,                    writefh=NULL,
                        stripread=NULL,                 lock=NULL;

        struct  InfoData                *i_data;

        BOOL    success=FALSE,                  private=FALSE,                  
                        msgbase=FALSE,                  error=FALSE,
                        del_file,                               nosentby=TRUE,
                        out=FALSE,                              multi_sentby,                   conf_sentby,
                        sentby_1=TRUE,                  sentby_2=TRUE,                  centhold=FALSE,
                        autofree=FALSE,                 delayup=FALSE,                  match=FALSE,
                        alreadydelayed=FALSE,   add_fileid=FALSE,               autofree_mail,
                        fiddate=FALSE,                  dlc,                                    fileid_add=FALSE,
                        confbgadd=FALSE,                newsentby=FALSE,                dupe_check=FALSE,
                        dupecheckglobal=FALSE,  dupe=FALSE, adddupelog=FALSE;

        struct  Filedata        *filedata=NULL;
        struct  DateStamp       *datestamp=NULL;


        if (argc<2)
        {
                printf("%s","\n[1mPlease don`t try to run the Backgroundfilehandler yourself![0m\n\n");
                Exit(5);
        }
        strcpy(filename,argv[1]);
        upperstring(filename);
        Forbid();
        filedata=(struct Filedata *)FindSemaphore(filename);
        Permit();
        
        if (!filedata) 
        {
                printf("%s","\n[1mPlease don`t try to run the Backgroundfilehandler yourself![0m\n\n");
                Exit(5);
        }
        


        timenow(timestr);
        strcpy (buffer,filename);
        if (chp=strrchr(buffer,'.')) strcpy(endung,chp+1);


        ObtainSemaphore((struct SignalSemaphore *) filedata);

        if (filedata->bghandler) 
        {
                ReleaseSemaphore((struct SignalSemaphore *) filedata);
                Exit(5);
        }
        else 
        {
                filedata->bghandler=TRUE;
        }
        strcpy(filepath,filedata->filepath);
        strcpy(nodenumber,filedata->nodenumber);        
        alreadydelayed=filedata->Immediately;   
        msgbase=filedata->MsgBase;
        strcpy(handle,filedata->handle);        
        strcpy(confpath,filedata->confpath);
        dirinkbyte=atoi(filedata->dirinkbyte);
        strcpy(slotnumber,filedata->slotnumber);
        strcpy(slot,slotnumber);
        add_fileid=filedata->add_fileid;
        delayup=filedata->Delay;
        sprintf(buffer,"%s%s",filepath,filename);
        mailaxx2=filedata->axx;
        filesize=GetFileSize(buffer);
        filedata->Filesize=filesize;
        confnumber=filedata->confnumber;
        ReleaseSemaphore((struct SignalSemaphore *)filedata);

        sprintf(buffer,"%s%s",filepath,filename);
        if (access(buffer,F_OK))
        {
                RemSemaphore((struct SignalSemaphore *)filedata);
                ObtainSemaphore((struct SignalSemaphore *)filedata);
                ReleaseSemaphore((struct SignalSemaphore *)filedata);
                FreeMem(filedata,sizeof(struct Filedata));
                exit(0);
        }               

        strcpy(buffer,"bbs:bgcheck/bgfilehandler.config");
        readfh=Open(buffer,MODE_OLDFILE);
        if (readfh) 
        {
                for (pos=0;FGets(readfh,buffer,254);pos++)
                {
                        main_config=(char **) realloc(main_config,(pos+1)*sizeof(char *));
                        main_config[pos]=NULL;
                        len=strlen(buffer);
                        if (buffer[len-1]=='\n') buffer[--len]='\0';
                        upperstring(buffer);
                                main_config[pos]=(char *) malloc (len+1);
                        if (main_config[pos]!=NULL)
                                strcpy(main_config[pos],buffer);
                }
                Close(readfh);
                main_config=(char **) realloc(main_config,(pos+1)*sizeof(char *));
                main_config[pos]=NULL;
        }
        else
        {
                main_config=(char **) realloc(main_config,sizeof(char *));
                main_config[0]=NULL;
        }


        p=getconfig(main_config,"AUTOFREE_MAIL_AXX");
        if (p)
        {
                strncpy(buffer,p,9);
                if (atoi(buffer))
                {
                        mailaxx=atoi(buffer);
                }
        }

        strcpy(buffer2,handle);
        upperstring(handle);
        sprintf(buffer,"AUTOFREE_MAIL_AXX_%s",handle);
        p=getconfig(main_config,buffer);
        if (p)
        {
                mailaxx2=mailaxx+1;
        }
        strcpy(handle,buffer2);



        if (p=getconfig(main_config,"FILELIST_DATEFORMAT_CDN")) dateformat=FORMAT_CDN;
        Date(date,dateformat);

        sprintf(buffer,"bbs:bgcheck/Sentby/Sentby.%s",slot);
        lock  = Lock( buffer, ACCESS_READ );
        if (lock)
        {
                fh = OpenFromLock(lock);
                if (!fh) UnLock(lock);
                else
                {
                        FGets(fh,sentby,50);
                        Close(fh);
                }
                if (sentby[strlen(sentby)-1]=='\n') sentby[strlen(sentby)-1]='\0';

        }
        nosentby=TRUE;
        for (counter=0;sentby[counter]!='\0';counter++)
        {       
                if (nosentby) 
                {
                        if (sentby[counter]!=' ') 
                        {
                                nosentby=FALSE;
                        }
                }
        }       

        del_file        =       getconfigbool(main_config,"DELETE_FILE",        TRUE);
        conf_sentby     =       getconfigbool(main_config,"CONF_SENTBY",        FALSE);
        multi_sentby=   getconfigbool(main_config,"MULTI_SENTBY",       TRUE);
        autofree_mail=  getconfigbool(main_config,"AUTOFREE_MAIL",      TRUE);
        dlc                     =       getconfigbool(main_config,"DOWNLOAD_COUNTER",TRUE);
        
        

        if (p=getconfig(main_config,"CENTRAL_HOLD_PATH"))
        {
                centhold=TRUE;
                strcpy(centholdpath,p);
                if(strlen(centholdpath)>0)
                {
                        if(centholdpath[strlen(centholdpath)-1]!='/' && centholdpath[strlen(centholdpath)-1]!=':')
                        {
                                strcat(centholdpath,"/");
                        }
                }
                else
                {
                        centhold=FALSE;
                }
        }
        if (p=getconfig(main_config,"DOWNLOAD_COUNTER_SPEC_CONFS"))
        {
                sprintf(buffer,"DOWNLOAD_COUNTER_CONF_%d",confnumber);
                if (p=getconfig(main_config,buffer))    dlc=TRUE; else dlc=FALSE;
        }



        if (endung[0]!=0)
        {
                sprintf(buffer,"FILE_ID_DATE_%s",endung);
                if (p=getconfig(main_config,buffer)) fiddate=TRUE;
        }
        if (p=getconfig(main_config,"FILEID_ADD.0")) fileid_add=TRUE;
        if (p=getconfig(main_config,"MAX_FILEID_LINES")) maxfidlines=atoi(p);
        if (p=getconfig(main_config,"COLOUR_SENT1_BRACKET")) strcpy(colour_sent1_bracket,p);
        if (p=getconfig(main_config,"COLOUR_SENT1_SENTBY")) strcpy(colour_sent1_sentby,p);
        if (p=getconfig(main_config,"COLOUR_SENT1_NODE")) strcpy(colour_sent1_node,p);
        if (p=getconfig(main_config,"COLOUR_SENT1_TIME")) strcpy(colour_sent1_time,p);
        if (p=getconfig(main_config,"COLOUR_SENT2")) strcpy(colour_sent2,p);
        if (p=getconfig(main_config,"AUTOFREE_COMMENT")) strcpy(free_comment,p);
        if (p=getconfig(main_config,"FILEID_ADD_SPECIAL_CONFS")) confbgadd=TRUE;
        if (p=getconfig(main_config,"NEW_SENTBY")) newsentby=TRUE;
        if (p=getconfig(main_config,"DUPECHECK")) dupe_check=TRUE;
        if (dupecheck) if (p=getconfig(main_config,"DUPECHECK_GLOBAL")) dupecheckglobal=TRUE;
		sprintf(buffer,"NO_DUPECHECK_%s",nodenumber);
        if (dupecheck) if (p=getconfig(main_config,buffer)) dupe_check=FALSE;
		sprintf(buffer,"ADD_DUPELOG_%s",nodenumber);
		if (!dupe_check) if (p=getconfig(main_config,buffer)) adddupelog=TRUE;

        if (p=getconfig(main_config,"AUTOFREE_MAIL_FROMNAME")) 
        {
                if (strlen(p)>30)
                {
                        strncpy(autofree_mail_fromname,p,30);
                        autofree_mail_fromname[30]='\0';
                }
                else strcpy(autofree_mail_fromname,p);
        }
        if (p=getconfig(main_config,"AUTOFREE_MAIL_SUBJECT"))
        {
                if (strlen(p)>30)
                {
                        strncpy(autofree_mail_subject,p,30);
                        autofree_mail_subject[30]='\0';
                }
                else strcpy(autofree_mail_subject,p);
        }


        if (p=getconfig(main_config,"DELAY_PATH"))
        {
                strcpy(delaypath,p);
                len=strlen(delaypath);
                if (delaypath[len-1]!='/' && delaypath[len-1]!=':')
                {
                        strcat(delaypath,"/");
                } 
                
        }


/* dupecheck */

        if (!add_fileid && dupe_check && !msgbase) dupe=dupecheck(filedata,dupecheckglobal,buffer,buffer2);
        if (dupe)
        {
                pos=0;
                main_fileid=(char **) realloc(main_fileid,(pos+1)*sizeof(char *));
                main_fileid[pos]=NULL;
                len=strlen("DuplicateFile");
                main_fileid[pos]=(char *) malloc (len+1);                                       
                if (main_fileid[pos]!=NULL)
                        strcpy(main_fileid[pos],"DuplicateFile");
                pos++;
                main_fileid=(char **) realloc(main_fileid,(pos+1)*sizeof(char *));
                main_fileid[pos]=NULL;
        }

/* filecheck start */

        if (!add_fileid && !dupe) error=filecheck(endung,filedata,&fcheck,filepath,filename,handle,confpath,nodenumber,timestr,date);
        if (error)
        {
                pos=0;
                main_fileid=(char **) realloc(main_fileid,(pos+1)*sizeof(char *));
                main_fileid[pos]=NULL;
                len=strlen("Filecheck failed!");
                main_fileid[pos]=(char *) malloc (len+1);                                       
                if (main_fileid[pos]!=NULL)
                        strcpy(main_fileid[pos],"Filecheck failed!");
                pos++;
                main_fileid=(char **) realloc(main_fileid,(pos+1)*sizeof(char *));
                main_fileid[pos]=NULL;
        }
        
        if (dupe) error=dupe;

        if (error)
        {       
                success=TRUE;
                private=TRUE;
        }

/*filecheck end*/



        if (add_fileid && !error)
        {
                counter=0;
                sprintf(buffer,"t:Node%s%d",nodenumber,counter);
                while (lock=Lock(buffer,ACCESS_READ))
                {
                        UnLock(lock);
                        counter++;
                        sprintf(buffer,"t:Node%s%d",nodenumber,counter);
                }
                strcpy(exfilepath,buffer);
                lock=CreateDir(exfilepath);
                if (lock) UnLock(lock);
                sprintf(buffer,"t:%s",filename);
                sprintf(buffer2,"%s/file_id.diz",exfilepath);
                Rename(buffer,buffer2);

                
                sprintf(buffer,"PACK_%s",endung);
                if (endung[0]!=0)
                if(p=getconfig(main_config,buffer))
                {
                        strcpy(buffer,p);
                        sprintf(buffer4,"%s/",exfilepath);
                        replace (buffer,buffer2,buffer3,"%W",buffer4);
                        sprintf(buffer4,"%s%s",filepath,filename);
                        replace (buffer2,buffer,buffer3,"%P",buffer4);
                        System(buffer,NULL);
                }

                sprintf(buffer2,"%s/file_id.diz",exfilepath);

                GetFileDate(fileiddate,buffer2,dateformat);
                datestamp=GetFileDateTime(buffer2);

                main_fileid=(char **) realloc(main_fileid,sizeof(char *));
                main_fileid[0]=NULL;

                stripread=Open(buffer2,MODE_OLDFILE);
                if (stripread)
                {
                        for (pos=0;FGets(stripread,buffer,100);pos++)
                        {
                                main_fileid=(char **) realloc(main_fileid,(pos+1)*sizeof(char *));
                                main_fileid[pos]=NULL;
                                len=strlen(buffer);
                                if (buffer[len-1]=='\n') buffer[len-1]='\0';
                                main_fileid[pos]=(char *) malloc (len+1);
                                if (main_fileid[pos]!=NULL)
                                        strcpy(main_fileid[pos],buffer);
                        }
                        Close(stripread);
                        main_fileid=(char **) realloc(main_fileid,(pos+1)*sizeof(char *));
                        main_fileid[pos]=NULL;
                }
                DeleteFile(buffer2);
                DeleteFile(exfilepath);
                success=TRUE;
                ObtainSemaphore((struct SignalSemaphore *) filedata);
                filedata->file_id=TRUE;
                ReleaseSemaphore((struct SignalSemaphore *) filedata);
                
        }
        if (!add_fileid && !error)
        {
                counter=0;
                sprintf(buffer,"t:Node%s%d",nodenumber,counter);
                while ((lock=Lock(buffer,ACCESS_READ)))
                {
                        UnLock(lock);
                        counter++;
                        sprintf(buffer,"t:Node%s%d",nodenumber,counter);
                }
                strcpy(exfilepath,buffer);
                lock=CreateDir(exfilepath);
                if (lock) UnLock(lock);
                
                sprintf(buffer,"DEPACK_%s",endung);
                if (endung[0]!=0)
                if(p=getconfig(main_config,buffer))
                {
                        strcpy(buffer,p);
                        sprintf(buffer4,"%s/",exfilepath);
                        replace (buffer,buffer2,buffer3,"%W",buffer4);
                        sprintf(buffer4,"%s%s",filepath,filename);
                        replace (buffer2,buffer,buffer3,"%P",buffer4);
                        System(buffer,NULL);
                }

                sprintf(buffer2,"%s/file_id.diz",exfilepath);

                
                GetFileDate(fileiddate,buffer2,dateformat);             
                datestamp=GetFileDateTime(buffer2);


                main_fileid=(char **) realloc(main_fileid,sizeof(char *));
                main_fileid[0]=NULL;

                ObtainSemaphore((struct SignalSemaphore *) filedata);
                stripread=Open(buffer2,MODE_OLDFILE);
                if (stripread)
                {
                        for (pos=0;FGets(stripread,buffer,100);pos++)
                        {
                                main_fileid=(char **) realloc(main_fileid,(pos+1)*sizeof(char *));
                                main_fileid[pos]=NULL;
                                len=strlen(buffer);
                                if (buffer[len-1]=='\n') buffer[len-1]='\0';
                                main_fileid[pos]=(char *) malloc (len+1);                                       
                                if (main_fileid[pos]!=NULL)
                                        strcpy(main_fileid[pos],buffer);
                        }
                        Close(stripread);
                        main_fileid=(char **) realloc(main_fileid,(pos+1)*sizeof(char *));
                        main_fileid[pos]=NULL;
                        success=TRUE;
                        filedata->file_id=TRUE;
                }
                else
                {
                        filedata->file_id=FALSE;
                        success=FALSE;
                }
                filedata->file_id_passed=TRUE;
                ReleaseSemaphore((struct SignalSemaphore *) filedata);
                SetProtection(buffer2,FIBB_DELETE);
                DeleteFile(buffer2);
                DeleteFile(exfilepath); 
        }
        if (success && !error)
        {


                /*Fileid_add*/
                if (fileid_add)
                {               
                        sprintf(buffer,"FILEID_ADD_CONF_%d",confnumber);
                        if (!confbgadd || (confbgadd && (p=getconfig(main_config,buffer))))
                        {
                                struct  ansi            *ansi;
                                ansi=(struct ansi *)  malloc(sizeof(struct ansi)) ;
                                sprintf(buffer,"ENV:Last_FileID_add");
                                readfh=Open(buffer,MODE_READWRITE);
                                if (!readfh) readfh=Open(buffer,MODE_NEWFILE);
                                while (!readfh)
                                {
                                        Delay (50);
                                        readfh=Open(buffer,MODE_NEWFILE);
                                }
                        
                                FGets(readfh,buffer,255);
                                len=atoi(buffer);
                                len++;
                                sprintf(buffer,"FILEID_ADD.%d",len);
                                p=getconfig(main_config,buffer);
                                if (!p) 
                                {
                                        len=0;
                                        sprintf(buffer,"FILEID_ADD.%d",len);
                                        p=getconfig(main_config,buffer);
                                }
                                Seek(readfh,0,OFFSET_BEGINNING);
                                sprintf(buffer,"%d\n",len);
                                FPuts(readfh,buffer);
                                Close(readfh);                  
        
                                strcpy(buffer,p);
                                if (p=getconfig(main_config,"FILEID_DATEFORMAT_CDN")) Date(buffer4,FORMAT_CDN); 
                                else Date(buffer4,FORMAT_USA);
        
                                replace (buffer,buffer2,buffer3,"@@/@@/@@",buffer4);
                                replace (buffer2,buffer,buffer3,"@#:@#",timestr);
                                ansi->ansicode=0;
                                stripansi(buffer,buffer2,ansi,0,0);
                                free(ansi);
                                sprintf(fileid_ad,"%.45s",buffer2);
        
                                counter=0;
                                sprintf(buffer,"t:Node%s%d",nodenumber,counter);
                                while ((lock=Lock(buffer,ACCESS_READ)))
                                {
                                        UnLock(lock);
                                        counter++;
                                        sprintf(buffer,"t:Node%s%d",nodenumber,counter);
                                }
                                strcpy(exfilepath,buffer);
                                lock=CreateDir(exfilepath);
                                if (lock) UnLock(lock);
                                sprintf(buffer2,"%s/file_id.diz",exfilepath);
                                writefh=Open(buffer2,MODE_NEWFILE);
                                pos=0;
                                while (main_fileid[pos])
                                {
                                        FPuts(writefh,main_fileid[pos]);
                                        FPuts(writefh,"\n");
                                        pos++;
                                }
                                FPuts(writefh,fileid_ad);
                                FPuts(writefh,"\n");
                                Close(writefh);
                                sprintf(buffer,"%s/file_id.diz",exfilepath);
                                SetFileDate(buffer, datestamp);
                                free(datestamp);        
                

                                if (endung[0]!=0)
                                {       

                                        sprintf(buffer,"DELETE_%s",endung);
                                        if(p=getconfig(main_config,buffer))
                                        {
                                                strcpy(buffer,p);
                                                sprintf(buffer4,"%s/",exfilepath);
                                                replace (buffer,buffer2,buffer3,"%W",buffer4);
                                                sprintf(buffer4,"%s%s",filepath,filename);
                                                replace (buffer2,buffer,buffer3,"%P",buffer4);
                                                System(buffer,NULL);
                                        }       



                                        sprintf(buffer,"PACK_%s",endung);
                                        if(p=getconfig(main_config,buffer))
                                        {
                                                strcpy(buffer,p);
                                                sprintf(buffer4,"%s/",exfilepath);
                                                replace (buffer,buffer2,buffer3,"%W",buffer4);
                                                sprintf(buffer4,"%s%s",filepath,filename);
                                                replace (buffer2,buffer,buffer3,"%P",buffer4);
                                                System(buffer,NULL);
                                        }
                                }
                                sprintf(buffer,"%s/file_id.diz",exfilepath);
                                DeleteFile(buffer);
                                DeleteFile(exfilepath); 
                        }
                }





                

                





                pos=0;
                sprintf(buffer,"AUTOFREE.%d",pos);
                while (p=getconfig(main_config,buffer))
                {
                        strcpy(buffer,p);       
                        upperstring(buffer);
                        ParsePattern(buffer,buffer2,300);
                        if (MatchPattern(buffer2,filename))
                        {
                                autofree=TRUE;
                        }
                        pos++;
                        sprintf(buffer,"AUTOFREE.%d",pos);
                }


                main_fileid=strip(main_fileid,maxfidlines);

                if (main_fileid[0][0]=='/') 
                {
                        ObtainSemaphore((struct SignalSemaphore *) filedata);
                        if (!msgbase) filedata->Hold=TRUE;
                        ReleaseSemaphore((struct SignalSemaphore *) filedata);
                        if (!msgbase) private=TRUE;
                }

                if (!newsentby)
                {
        
                        if (multi_sentby) 
                        {
                                if (nosentby)
                                {
                                        sentby_1=TRUE;
                                        sentby_2=FALSE;
                                }
                                        else
                                {
                                        sentby_1=sentby_2=TRUE;
                                }
                        }
                        else
                        {
                                if (nosentby)
                                {       
                                        sentby_1=TRUE;
                                                sentby_2=FALSE;
                                }       
                                else 
                                {
                                        sentby_1=FALSE;
                                        sentby_2=TRUE;
                                }
                        }
                        if (sentby_2)
                        {
                                if (conf_sentby)
                                {
                                        sprintf(buffer,"%sSentby",confpath);
                                        fh=Lock(buffer,ACCESS_READ);
                                        if (fh)
                                        {
                                                UnLock(fh);
                                        }
                                        else
                                        {
                                                sentby_2=FALSE;
                                        }
                                }
                        }
                        if ((sentby_2==FALSE) && (sentby_1==FALSE)) 
                        {
                                sentby_1=TRUE;
                        }
                        if (sentby_1)
                        {
                                pos=0;
                                if (colour_sent1_bracket[0]!=0 || colour_sent1_sentby[0]!=0 || colour_sent1_node[0]!=0 || colour_sent1_time[0]!=0) strcpy (colour_clear,"[0m");
                                while(main_fileid[pos]) pos++;
                                sprintf (buffer,"%s[%s%-28.28s%s]%s %s[%s#%2.2s%s]%s %s[%s%s%s]%s",colour_sent1_bracket,colour_sent1_sentby,handle,colour_sent1_bracket,colour_clear,colour_sent1_bracket,colour_sent1_node,nodenumber,colour_sent1_bracket,colour_clear,colour_sent1_bracket,colour_sent1_time,timestr,colour_sent1_bracket,colour_clear);
                                len=strlen(buffer);
                                main_fileid[pos]=(char *) malloc (len+1);
                                if (main_fileid[pos]!=NULL)
                                        strcpy(main_fileid[pos],buffer);
                                main_fileid=(char **) realloc(main_fileid,(pos+2)*sizeof(char *));
                                main_fileid[pos+1]=NULL;
                        }
                        if (sentby_2)
                        {
                                pos=0;
                                strcpy(colour_clear,"");
                                if (colour_sent2[0]!=0) strcpy(colour_clear,"[0m");
                                while(main_fileid[pos]) pos++;
                                sprintf (buffer,"%s%s%s",colour_sent2,sentby,colour_clear);
                                len=strlen(buffer);
                                main_fileid[pos]=(char *) malloc (len+1);
                                if (main_fileid[pos]!=NULL)
                                        strcpy(main_fileid[pos],buffer);
                                main_fileid=(char **) realloc(main_fileid,(pos+2)*sizeof(char *));
                                main_fileid[pos+1]=NULL;
                        }
                }
                else
                {
                        if (colour_sent1_bracket[0]!=0 || colour_sent1_sentby[0]!=0 || colour_sent1_node[0]!=0 || colour_sent1_time[0]!=0) strcpy (colour_clear,"[0m");
                        pos=0;
                        if (strlen(sentby)==0) strcpy(buffer2,handle); else strcpy(buffer2,sentby);

                        while (main_fileid[pos]) pos++;
                        sprintf (buffer,"%s[%s%-34.34s%s]%s %s[%s%s%s]%s",colour_sent1_bracket,colour_sent1_sentby,buffer2,colour_sent1_bracket,colour_clear,colour_sent1_bracket,colour_sent1_time,timestr,colour_sent1_bracket,colour_clear);
                        len=strlen(buffer);
                        main_fileid[pos]=(char *) malloc (len+1);
                        if (main_fileid[pos]!=NULL)
                                strcpy(main_fileid[pos],buffer);
                        main_fileid=(char **) realloc(main_fileid,(pos+2)*sizeof(char *));
                        main_fileid[pos+1]=NULL;
                }

                if (autofree)
                {
                        pos=0;
                        while(main_fileid[pos]) pos++;
                        sprintf (buffer,"%s",free_comment);
                        len=strlen(buffer);
                        main_fileid[pos]=(char *) malloc (len+1);
                        if (main_fileid[pos]!=NULL)
                                strcpy(main_fileid[pos],buffer);
                        main_fileid=(char **) realloc(main_fileid,(pos+2)*sizeof(char *));
                        main_fileid[pos+1]=NULL;
                }






                /* Starttool */
                pos=0;  
                sprintf(buffer,"START_TOOL.%d",pos);
                while (p=getconfig(main_config,buffer))
                {
                        if (p[0])
                        {       
                                strcpy(buffer,p);
                                replace(buffer,buffer2,buffer3,"%P",filepath);
                                replace(buffer2,buffer,buffer3,"%F",filename);
                                replace(buffer,buffer2,buffer3,"%H",handle);
                                replace(buffer2,buffer,buffer3,"%C",confpath);
                                replace(buffer,buffer2,buffer3,"%N",nodenumber);
                                replace(buffer2,buffer,buffer3,"%T",timestr);
                                replace(buffer,buffer2,buffer3,"%D",date);
                                strcpy(starttool,buffer2);
                                System (starttool,NULL);
                        }
                        pos++;
                        sprintf(buffer,"START_TOOL.%d",pos);    
                }
                /* Starttool end*/





        }

        if (success)
        {
                if(!msgbase)
                {               

                        main_filepaths=(char **) realloc(main_filepaths,sizeof(char *));
                        main_filepaths[0]=NULL;
                        sprintf(buffer,"%sULPaths",confpath);
                        readfh=Open(buffer,MODE_OLDFILE);
                        for (counter=0;FGets(readfh,buffer,100);counter++)
                        {
                                main_filepaths=(char **) realloc(main_filepaths,(counter+1)*sizeof(char *));
                                main_filepaths[counter]=NULL;
                                        len=strlen(buffer);
                                if (buffer[len-1]=='\n') buffer[len-1]='\0';
                                main_filepaths[counter]=(char *) malloc (len+1);
                                        if (main_filepaths[counter]!=NULL)
                                        strcpy(main_filepaths[counter],buffer);
                        }
                        Close(readfh);
                        main_filepaths=(char **) realloc(main_filepaths,(counter+1)*sizeof(char *));
                        main_filepaths[counter]=NULL;
                        
                        if(i_data=(struct InfoData *)AllocMem((long)sizeof(struct InfoData),MEMF_PUBLIC|MEMF_CLEAR)) 
                        {
                                for (counter=0;(main_filepaths[counter]!=NULL && (!out));counter++)
                                {
                                        readfh=Lock(main_filepaths[counter],ACCESS_READ);
                                        if( readfh ) 
                                        {
                                                if(Info(readfh,i_data))
                                                {
                                                        stat=(i_data->id_NumBlocks*i_data->id_BytesPerBlock)-(i_data->id_NumBlocksUsed*i_data->id_BytesPerBlock);
                                                }
                                                if (stat>filesize) out=TRUE;
                                                UnLock(readfh);
                                        }
                        }
                                counter--;
                                FreeMem(i_data,sizeof(struct InfoData));
                        }
        
                        if (main_filepaths[counter]!=NULL) strcpy(movetopath,main_filepaths[counter]);
                        

                        for (counter=0;main_filepaths[counter]!=NULL;counter++)
                                free(main_filepaths[counter]);
                        free (main_filepaths);          

                        if (alreadydelayed && !private) delayup=FALSE;
                        if (delayup && !private)
                        {
                                sprintf(buffer,"t:UploadDelay.%s",nodenumber);
                                readfh=Open(buffer,MODE_OLDFILE);
                                FGets(readfh,buffer,254); /* Date */
                                strcpy(delaydate,buffer);
                                FGets(readfh,buffer,254); /*  Time */
                                strcpy(delaytime,buffer);
                                match=FALSE;
                                while (FGets(readfh,buffer,254))
                                {
                                        if (buffer[strlen(buffer)-1]=='\n') buffer[strlen(buffer)-1]='\0';
                                        len=ParsePattern(buffer,buffer2,300);
                                        if (len==1)
                                        {
                                                if (MatchPattern(buffer2,filename))
                                                        match=TRUE;
                                        }
                                        if (len==0)
                                        {
                                                if (0==(strcmp(buffer,filename)))
                                                        match=TRUE;
                                        }
                                }
                                Close(readfh);
                                if (match)
                                {
                                        strcpy(buffer,delaypath);
                                        len=strlen(buffer);
                                        if (buffer[len-1]=='/') buffer[len-1]='\0';
                                        lock  = Lock( buffer, ACCESS_READ );
                                        if (lock) UnLock(lock);
                                        else 
                                        {
                                                lock = CreateDir(buffer);
                                                if (lock) UnLock(lock);
                                        }       
                                        sprintf(buffer,"%s%s",filepath,filename);
                                        sprintf(buffer2,"%s%s",delaypath,filename);
                                        copy(buffer,buffer2);
                                        ObtainSemaphore((struct SignalSemaphore *) filedata);
                                        strcpy(filedata->movetopath,buffer2);
                                        ReleaseSemaphore((struct SignalSemaphore *) filedata);                                          
                                        strcat(buffer2,".dat");
                                        readfh=Open(buffer2,MODE_NEWFILE);
                                        if (readfh)
                                        {
                                                FPuts(readfh,delaydate);
                                                FPuts(readfh,delaytime);
                                                sprintf(buffer,"%s\n",filename);
                                                FPuts(readfh,buffer);
                                                sprintf(buffer,"%s\n",filepath);
                                                FPuts(readfh,buffer);
                                                sprintf(buffer,"%s\n",nodenumber);
                                                FPuts(readfh,buffer);
                                                sprintf(buffer,"%s\n",handle);
                                                FPuts(readfh,buffer);
                                                sprintf(buffer,"%s\n",confpath);
                                                FPuts(readfh,buffer);
                                                sprintf(buffer,"%d\n",dirinkbyte);
                                                FPuts(readfh,buffer);
                                                sprintf(buffer,"%s\n",slotnumber);
                                                FPuts(readfh,buffer);
                                                sprintf(buffer,"%d\n",confnumber);
                                                FPuts(readfh,buffer);
                                                Close(readfh);
                                        }
                                        ObtainSemaphore((struct SignalSemaphore *) filedata);
                                        filedata->Delay=TRUE;
                                        ReleaseSemaphore((struct SignalSemaphore *) filedata);
                                        System("run >nil: bbs:bgcheck/Delayhandler",NULL);
                                }
                                else
                                {
                                        delayup=FALSE;
                                }
                        }
                        if (!private && !delayup && !msgbase)
                        {
                                sprintf(buffer,"%sndirs",confpath);
                                readfh=Open(buffer,MODE_OLDFILE);
                                if (readfh)
                                {
                                        FGets(readfh,buffer,200);
                                        ndirs=atoi(buffer);
                                        Close(readfh);
                                }
                                if (ndirs)
                                {
                                        sprintf(buffer,"%sdir%d",confpath,ndirs);
                                        sprintf(buffer2,"%s%s",filepath,filename);
                                        sprintf(buffer3,"%s%s",movetopath,filename);
                                        putonline(filedata,buffer,main_fileid,buffer2,buffer3,del_file,dirinkbyte,dlc,filesize,filename,fcheck,date,fiddate,fileiddate);
                                        if (autofree) SetComment( buffer3, "FREE_DOWNLOAD" );
                                        if (autofree_mail && autofree && (mailaxx<=mailaxx2))
                                        {
                                                autofreemail(main_fileid,confnumber,autofree_mail_fromname,autofree_mail_subject,filename,filesize);
                                        }
                                }
                        }
                        if (private && !centhold && !msgbase)
                        {
                                sprintf(buffer,"%shold",confpath);
                                readfh=Lock(buffer,ACCESS_READ);
                                if (!readfh) 
                                {
                                        readfh=CreateDir(buffer);
                                        if (readfh) UnLock(readfh);
                                }
                                else UnLock(readfh);
                                sprintf(buffer,"%shold/held",confpath); 
                                sprintf(buffer2,"%s%s",filepath,filename);
                                sprintf(buffer3,"%sHold/%s",confpath,filename);
                                putonline(filedata,buffer,main_fileid,buffer2,buffer3,del_file,dirinkbyte,dlc,filesize,filename,fcheck,date,fiddate,fileiddate);
                        }
                        if (private && centhold && !msgbase)
                        {
                                strcpy(buffer,centholdpath);
                                if (buffer[strlen(buffer)-1]=='/') buffer[strlen(buffer)-1]='\0';
                                readfh=Lock(buffer,ACCESS_READ);
                                if (!readfh) 
                                {
                                        readfh=CreateDir(buffer);
                                        if (readfh) UnLock(readfh);
                                }
                                else    UnLock(readfh);
                                strcpy(buffer,centholdpath);
                                strcat(buffer,"held");
                                sprintf(buffer2,"%s%s",filepath,filename);
                                sprintf(buffer3,"%s%s",centholdpath,filename);
                                putonline(filedata,buffer,main_fileid,buffer2,buffer3,del_file,dirinkbyte,dlc,filesize,filename,fcheck,date,fiddate,fileiddate);
                        }
                        if (private && !msgbase)
                        {
                                ObtainSemaphore((struct SignalSemaphore *) filedata);
                                filedata->Hold=TRUE;
                                ReleaseSemaphore((struct SignalSemaphore *) filedata);
                        }
                }
        }


        if (!add_fileid && !msgbase && ((!dupe && dupe_check) || (adddupelog))) dupeadd(filedata,dupecheckglobal,buffer,buffer2);

        if (alreadydelayed && !error)
        {
                RemSemaphore((struct SignalSemaphore *)filedata);
                ObtainSemaphore((struct SignalSemaphore *)filedata);
                ReleaseSemaphore((struct SignalSemaphore *)filedata);
                FreeMem(filedata,sizeof(struct Filedata));
                sprintf(buffer,"%s%s",filepath,filename);

                DeleteFile(buffer);
        }



        for (pos=0;main_config[pos];pos++)
                free(main_config[pos]);
        free (main_config);
        
        if(!error)
        {
                for (pos=0;main_fileid[pos];pos++)
                        free(main_fileid[pos]);
                free (main_fileid);
        }

        ObtainSemaphore((struct SignalSemaphore *) filedata);
        if (filedata->file_id || !filedata->Filecheck_ok) filedata->all_passed=TRUE;
        ReleaseSemaphore((struct SignalSemaphore *) filedata);



}
