/************************************************/
                                                                                                                        /***/
#define REVISION "V1.0"                                                         /***/
#define REVDATE  "23.9.95"                                              /***/
#define PROGNAME "G^SUS - Leech list"
#define NAME     "LEECHLIST"                                            /***/
#define AUTHOR   "Joe Cool"                                             /***/
                                                                                                                        /***/
/************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <libraries/aedoor.h>
#include <proto/aedoor.h>
#include <proto/exec.h>
#include <clib/dos_protos.h>
//#include <AE.Includes/AdiDoorDefines.h>

#define MSG_PROGNAME            "\033[1m"PROGNAME"\033[0m"
#define MAXNAMELEN              256
#define ws WriteStr
#define sm sendmessage
#define pm prompt
#define gu getuserstring
#define pu putuserstring

#define Beep 0x07

static const char VersionTag[] = "\0$VER: "PROGNAME" "REVISION" ("REVDATE")";
char version[]= PROGNAME " " REVISION ;
char author[20]= AUTHOR ;

struct  Library *AEDBase;
struct  DIFace  *d;

char    *strf;

int Node;
/****************************************************************************/
void OpenLibs(void) 
{
        if((AEDBase=(struct Library *)OpenLibrary(AEDoorName,0))==NULL)
        {
                printf("Needs AEDoor.library V1.10+ to run\n");
                exit(10);
        }
}
/****************************************************************************/
void CloseLibs(void) 
{
        CloseLibrary(AEDBase);
}
/****************************************************************************/
/****************************************************************************/
/****************************************************************************/
/****************************************************************************/
void start(void)
{       FILE *ndirsfile=NULL;
        BPTR file=NULL,lock=NULL;
		BOOL *dirask=NULL,etwasausge=FALSE;
		struct FileInfoBlock *fileinfoblock=NULL;
        char *confpath=NULL,*confpathdir=NULL,
				**packername=NULL,**packercommand=NULL;
        char buffer[100]="[35m[[0mLeechin` List[35m][0m",
             commandline[100],
			 buffer2[100],
             fifochar;
        int  ndirs=0,auswahl=0,readsize=0,counter=0,numpack=0,len=0;

        ws(d,"",1);
        ws(d,buffer,0);
		ws(d,"  Reading configs...",1);


//*** get conference Path ***
		sprintf(commandline,"delete >nil: T:Filelst%d.lha",Node);
		Execute(commandline, NULL, NULL);
		sprintf(commandline,"delete >nil: T:Filelst%d.lzx",Node);
		Execute(commandline, NULL, NULL);
		sprintf(commandline,"delete >nil: T:Filelst%d.zip",Node);
		Execute(commandline, NULL, NULL);

        GetDT(d,BB_CONFLOCAL,0);
        confpath=(char *)malloc(sizeof(char)*(strlen(strf)+1));
        confpathdir=(char *)malloc(sizeof(char)*(strlen(strf)+7));

        strcpy(confpath,strf);
        strcpy(confpathdir,confpath);


//*** reading config file ***


		lock=GetProgramDir();
		if (!lock) ws (d,"Couldn`t get a Lock",1);
		if (NameFromLock(lock, buffer, 82)) ws (d,buffer,1);
		UnLock(lock);	
		sprintf(buffer2,"%s/"NAME".config",buffer);
		ws(d,buffer2,1);
		file=Open(buffer2,MODE_OLDFILE);
		if (!file) ws(d,"couldn`t open "NAME".config",1);
		FGets (file,buffer,99);
		numpack=atoi(buffer);
		packername=(char **)malloc(sizeof(char *)*numpack);
		packercommand=(char **)malloc(sizeof(char *)*numpack);
		for(counter=0;counter<=(numpack-1);counter++)
		{	
			FGets (file,buffer,99);
			len=strlen(buffer);
			packername[counter]=(char *)malloc(sizeof(char)*len+1);
			packername[counter]=strcpy(packername[counter],buffer);
			packername[counter][len-1]='\0';
			FGets (file,buffer,99);
			len=strlen(buffer);
			packercommand[counter]=(char *)malloc(sizeof(char)*len+1);
			packercommand[counter]=strcpy(packercommand[counter],buffer);
			packercommand[counter][len-1]='\0';
		}
		
	
		Close(file);



//*** reading ndirsfile   ***
 
        confpathdir=strcat(confpathdir,"ndirs");
        if (ndirsfile=fopen(confpathdir,"r"))
        {
                fgets(buffer,100,ndirsfile);
                ndirs=atoi(buffer);
                fclose(ndirsfile);
        
                if (ndirs>0)
                {
			dirask=(BOOL *)malloc(ndirs*sizeof(BOOL));
			ws(d,"c",1);
			ws(d,"[35m[[0mLeechin` List[35m][0m",1);
			for (counter=0;counter<=(ndirs-1);counter++)
			{
				dirask[counter]=FALSE;
				sprintf (buffer,"%d) (-)  Directory Nr. %d",counter+1,counter+1);
				ws (d,buffer,1);
			}

			
			
			

			auswahl=0;
			while (auswahl!=-1)
			{
				sprintf (buffer,"[%d;9f  [%d;0f",ndirs+3,ndirs+3);
				ws(d,buffer,0);
				Prompt( d, 2, "Auswahl:" );
				auswahl=atoi(strf);
				if (!(strcmp(strf,"a")) || !(strcmp(strf,"A")))
					for (counter=0;counter<=(ndirs-1);counter++)
					{
						dirask[counter]=TRUE;
						sprintf (buffer,"[%d;5f*",counter+3);
    				    ws (d,buffer,0);
					}
				if (!(strcmp(strf,"i")) || !(strcmp(strf,"I")))
					for (counter=0;counter<=(ndirs-1);counter++)
					{
						if (dirask[counter]==TRUE) 
							dirask[counter]=FALSE;
						else
							dirask[counter]=TRUE;
						if (dirask[counter]==TRUE)
       						sprintf (buffer,"[%d;5f*",counter+3);
    					else
        					sprintf (buffer,"[%d;5f-",counter+3);
					    ws (d,buffer,0);
					}
				if (!(strcmp(strf,"q")) || !(strcmp(strf,"q")))
					auswahl=-1;
			

				if ((auswahl>0) & (auswahl<=ndirs)) 
				{
					if (dirask[auswahl-1]==TRUE) 
						dirask[auswahl-1]=FALSE; 
					else 
						dirask[auswahl-1]=TRUE;
//					if (dirask[auswahl-1]==TRUE) 
//						sprintf (buffer,"%d) (*)  Directory Nr. %d",auswahl,auswahl);
//					else
//						sprintf (buffer,"%d) (-)  Directory Nr. %d",auswahl,auswahl);
					
					for (counter=0;counter<=(ndirs-1);counter++)
					{
						if (dirask[counter]==TRUE)
    						sprintf (buffer,"[%d;5f*",counter+3);
						else
    						sprintf (buffer,"[%d;5f-",counter+3);
						ws (d,buffer,0);
					}
				}
			}
			etwasausge=FALSE;
			for (counter=0;counter<=(ndirs-1);counter++)
				if (dirask[counter]==TRUE)
					etwasausge=TRUE;
			
				






//*** Asking which Packer ***

			if (etwasausge==TRUE)
			{
				ws(d,"[0mWelcher Packer",1);
				ws(d,"0) Quit",1);
				for (counter=1;counter<=numpack;counter++)
				{
					sprintf(buffer,"%d) %s",counter,packername[counter-1]);
					ws(d,buffer,1);
				}
				Prompt( d, 2, "Auswahl:" );
				auswahl=atoi(strf);
				if (auswahl==1) 
				{	
					ws (d,"Lha selected, please wait...",1);
					for (counter=0;counter<=(ndirs-1);counter++)
						if (dirask[counter]==TRUE)
						{	
							sprintf(buffer,"Packing Filelist Nr.%d...",counter+1);
							ws(d,buffer,1);
							sprintf(buffer,"dir%d",counter+1);
    						sprintf(commandline,"lha >NIL: a T:Filelst%d %s%s ",Node,confpath,buffer);
							Execute(commandline, NULL,NULL);
						}
				}
				if (auswahl==2)
				{
					ws (d,"Lzx selected, please wait...",1);
					for (counter=0;counter<=(ndirs-1);counter++)
						if (dirask[counter]==TRUE)
						{
							sprintf(buffer,"Packing Filelist Nr.%d...",counter+1);
							ws(d,buffer,1);
							sprintf(buffer,"dir%d",counter+1);
							sprintf(commandline,"lzx >NIL: a T:Filelst%d %s%s ",Node,confpath,buffer);
							Execute(commandline, NULL,NULL);
						}

				}

				if (auswahl==3)
				{
					ws (d,"Zip selected, please wait...",1);
					for (counter=0;counter<=(ndirs-1);counter++)
						if (dirask[counter]==TRUE)
						{
							sprintf(buffer,"Packing Filelist Nr.%d...",counter+1);
							ws(d,buffer,1);
							sprintf(buffer,"dir%d",counter+1);
							sprintf(commandline,"zip >NIL: T:Filelst%d %s%s ",Node,confpath,buffer);
							Execute(commandline, NULL,NULL);
						}

				}


			}
			else
				ws(d,"Nothing selected!",1);





//*** Sendin` that shit ***


			if ((etwasausge==TRUE) & (auswahl!=0))
			{
				if (auswahl==1) sprintf(buffer2,"lha");
				if (auswahl==2) sprintf(buffer2,"lzx");
				if (auswahl==3) sprintf(buffer2,"zip");
				sprintf (buffer,"t:Filelst%d.%s",Node,buffer2);
				    SetDT(d,JH_HK,">Slam a key to download!<");
					SetDT(d,ZMODEMSEND,buffer);
				sprintf(commandline,"delete >nil: T:Filelst%d.%s",Node,buffer2);
				Execute(commandline, NULL, NULL);
				ws(d,"",1);
			}
		}
		else
			ws(d,"es gibt keine filedir",1);
	}
	else
		ws(d,"es gibt kein ndirs-file",1);

	for (counter=0;counter<=(numpack-1);counter++)
	{
		free(packername[counter]);
		free(packercommand[counter]);
	}
	free(packername);
	free(packercommand);
	free(confpath);
}
/****************************************************************************/
main(argc, argv)
int argc;
char *argv[];
{
        if(argc!=2)
        {
                printf("\n%s: XIM-DOOR for S-Express!\n\n",version);
                exit(0);
        }
        Node=atoi(argv[1]);

        OpenLibs();
        d=CreateComm(argv[1][0]);
        strf= GetString(d);

        start();

        CloseLibs();
        DeleteComm(d);
}
